VERSION 5.00
Begin VB.Form QueryTest 
   Caption         =   "Test Prolog Query Object"
   ClientHeight    =   735
   ClientLeft      =   60
   ClientTop       =   375
   ClientWidth     =   4440
   LinkTopic       =   "Form1"
   ScaleHeight     =   735
   ScaleWidth      =   4440
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton butnTest 
      Caption         =   "Perform Consultation"
      Height          =   375
      Left            =   1200
      TabIndex        =   0
      Top             =   240
      Width           =   1935
   End
End
Attribute VB_Name = "QueryTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim ipQuery As PrologQuery


Private Sub butnTest_Click()
    TestQuery
End Sub

Private Sub Form_Load()
    Set ipQuery = New PrologQuery
End Sub

Function CountQueries() As Long
    On Error GoTo CQ_exit
    Dim rgArgs() As Variant
    Dim cQuery As Integer
    cQuery = 0
    While ipQuery.NextSolution(rgArgs)
        cQuery = cQuery + 1
    Wend
CQ_exit:
    CountQueries = cQuery
    Exit Function
End Function
Sub TestQuery()
    Dim rgArgs() As Variant
    Dim cQuery As Integer
    Dim sPath As String
    Dim sQueryPath As String
    Dim sCurDir As String
        
    On Error GoTo tq_end
    sCurDir = CurDir
    '  Display the path to the SWI binaries
    sPath = ipQuery.ModulePath
    MsgBox sPath & " (" & sCurDir & ")", vbOKOnly, "SWI Path"
    
    '  Query 1: consult the file
    sQueryPath = sPath & "..\src\win32\foreign\proquery\vb\proqtest.pl"
    ReDim rgArgs(0)
    rgArgs(0) = sQueryPath
    ipQuery.SetPredicate "consult", 1, "system"
    ipQuery.OpenQuery 0, rgArgs
    cQuery = CountQueries
    MsgBox "Query succeeded " & cQuery & " times", vbOKOnly, "Query Results"
    ipQuery.CloseQuery
    
    ' Query 2: very simple
    ipQuery.SetPredicate "owner", 1, "user"
    ReDim rgArgs(0)
    rgArgs(0) = Empty
    ipQuery.OpenQuery 0, rgArgs
    If ipQuery.NextSolution(rgArgs) Then
        MsgBox "Query owner (1), result = " & rgArgs(0), vbOKOnly, "Test Query"
    Else
        MsgBox "Query owner (1): query failed", vbOKOnly, "Test Query"
    End If
    If ipQuery.NextSolution(rgArgs) Then
        MsgBox "Query owner (2), result = " & rgArgs(0), vbOKOnly, "Test Query"
    Else
        MsgBox "Query owner (2): query failed", vbOKOnly, "Test Query"
    End If
    ipQuery.CloseQuery
        
    ' Query 3: test print
    ipQuery.SetPredicate "testPrint", 1, "user"
    ReDim rgArgs(0)
    rgArgs(0) = "Test Line"
    ipQuery.OpenQuery 0, rgArgs
    If ipQuery.NextSolution(rgArgs) Then
        MsgBox "Query testPrint, result = " & rgArgs(0), vbOKOnly, "Test Query"
    Else
        MsgBox "Query testPrint: query failed", vbOKOnly, "Test Query"
    End If
    ipQuery.CloseQuery
    
    Exit Sub
    
tq_end:
    MsgBox "Query processing failed", vbOKOnly, "Test Query"
    Exit Sub
End Sub
